(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      9432,        383]*)
(*NotebookOutlinePosition[     10131,        407]*)
(*  CellTagsIndexPosition[     10087,        403]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["RSA-Codierung", "Title"],

Cell["Verschl\[UDoubleDot]sselung - Chiffrierung", "Subtitle"],

Cell[TextData[{
  "Wir w\[ADoubleDot]hlen zwei Primzahlen ",
  StyleBox["p",
    FontWeight->"Bold"],
  " und ",
  StyleBox["q",
    FontWeight->"Bold"],
  " - ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " unterst\[UDoubleDot]tzt mit Befehlen ",
  StyleBox["PrimeQ[z",
    FontWeight->"Bold"],
  "] und ",
  Cell[BoxData[
      FormBox[
        StyleBox[\(NextPrime[z]\),
          FontWeight->"Bold"], TraditionalForm]]],
  " bzw.",
  StyleBox[" PreviousPrime[z]",
    FontWeight->"Bold"],
  " - der \[CapitalUDoubleDot]berpr\[UDoubleDot]fung, ob eine Zahl z eine \
Primzahl ist bzw. der Berechnung der zur eingegebenen nat\[UDoubleDot]rlichen \
Zahl n\[ADoubleDot]chstgelegenen Primzahl gr\[ODoubleDot]\[SZ]er z (Next) \
oder kleiner z (Previous).\nAnschlie\[SZ]end erzeugen wir die Produkte ",
  StyleBox["n = p q",
    FontWeight->"Bold"],
  " und ",
  StyleBox["m = (p-1) (y-1)",
    FontWeight->"Bold"],
  "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(z1 = 24201842; p = NextPrime[z1]\)], "Input"],

Cell[BoxData[
    \(24201869\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[p]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(z2 = 51200499; q = NextPrime[z2]\)], "Input"],

Cell[BoxData[
    \(51200509\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrimeQ[q]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(n = p\ q\)], "Input"],

Cell[BoxData[
    \(1239148011551321\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(m = \((p - 1)\) \((q - 1)\)\)], "Input"],

Cell[BoxData[
    \(1239147936148944\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "Wir brauchen neben n noch den zweiten Teil des \[ODoubleDot]ffentlichen \
Schl\[UDoubleDot]ssels, eine Zahl ",
  StyleBox["a",
    FontWeight->"Bold"],
  ", die teilerfremd zu m is. Die \[CapitalUDoubleDot]berpr\[UDoubleDot]fung \
geht \[UDoubleDot]ber die Frage: ist der gr\[ODoubleDot]\[SZ]te gemeinsame \
Teiler gleich 1, GGT(m,a) = 1, ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " Funktion dazu lautet ",
  StyleBox["GCD[a,b]",
    FontWeight->"Bold"],
  ".\nWir w\[ADoubleDot]hlen eine beliebige Zahl, erzeugen die \
n\[ADoubleDot]chstgelegene Primzahl und \[UDoubleDot]berpr\[UDoubleDot]fen \
den GGT."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(z3 = 7812; a = NextPrime[z3]\)], "Input"],

Cell[BoxData[
    \(7817\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(GCD[m, a]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "Damit ist mit den beiden Zahlen ",
  StyleBox["n",
    FontWeight->"Bold"],
  " und ",
  StyleBox["a",
    FontWeight->"Bold"],
  " der \[ODoubleDot]ffentliche Schl\[UDoubleDot]ssel fertiggestellt.\nDie \
Verschl\[UDoubleDot]sselung kann damit \[UDoubleDot]ber die Formel\n",
  StyleBox["y = x^a mod n",
    FontWeight->"Bold"],
  "\nerfolgen.\n\n",
  "Wir verschl\[UDoubleDot]sseln den Text \"KRYPTOGRAFIE\" - dazu wandeln wir \
die Buchstaben in Zahlen um und verwenden daf\[UDoubleDot]r den international \
\[UDoubleDot]blichen ASCII-Code. Wir fassen jeweils 6 Buchstaben zu einer \
Gruppe zusammen und erhalten 12-stellige Zahlen."
}], "Text"],

Cell[BoxData[GridBox[{
        {"K", "R", "Y", "P", "T", "O"},
        {
          StyleBox["75",
            FontWeight->"Plain"], 
          StyleBox["82",
            FontWeight->"Plain"], 
          StyleBox["89",
            FontWeight->"Plain"], 
          StyleBox["80",
            FontWeight->"Plain"], 
          StyleBox["84",
            FontWeight->"Plain"], 
          StyleBox["79",
            FontWeight->"Plain"]},
        {"G", "R", "A", "F", "I", "E"},
        {
          StyleBox["71",
            FontWeight->"Plain"], 
          StyleBox["82",
            FontWeight->"Plain"], 
          StyleBox["65",
            FontWeight->"Plain"], 
          StyleBox["70",
            FontWeight->"Plain"], 
          StyleBox["73",
            FontWeight->"Plain"], 
          StyleBox["69",
            FontWeight->"Plain"]}
        },
      GridFrame->True,
      RowLines->True,
      ColumnLines->True]], "Input"],

Cell[BoxData[{
    StyleBox[\(Wir\ verwenden\ den\ \ Befehl\),
      "Text",
      FontWeight->"Plain"], "\[IndentingNewLine]", 
    RowBox[{
      StyleBox[\(PowerMod[x, a, n]\),
        "Text",
        FontWeight->"Bold"], 
      StyleBox["-",
        "Text",
        FontWeight->"Plain"], 
      RowBox[{
        StyleBox["Resultat",
          "Text",
          FontWeight->"Plain"], 
        StyleBox[" ",
          "Text",
          FontWeight->"Plain"], 
        StyleBox["von",
          "Text",
          FontWeight->"Plain"], 
        StyleBox[" ",
          "Text",
          FontWeight->"Plain"], 
        StyleBox[\(x^a\),
          "Text",
          FontWeight->"Bold"], 
        StyleBox[" ",
          "Text",
          FontWeight->"Bold"], 
        StyleBox["mod",
          "Text",
          FontWeight->"Bold"], 
        StyleBox[" ",
          "Text",
          FontWeight->"Bold"], 
        StyleBox["n",
          "Text",
          FontWeight->"Bold"]}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(text1 = 758289808479\)], "Input"],

Cell[BoxData[
    \(758289808479\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(text2 = 718265707369\)], "Input"],

Cell[BoxData[
    \(718265707369\)], "Output"]
}, Open  ]],

Cell[BoxData[
    StyleBox[\(und\ erhalten\ unsere\ chiffrierten\ \(\(Texte\)\(.\)\)\),
      "Text",
      FontWeight->"Plain"]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(chiffre1 = PowerMod[text1, a, n]\)], "Input"],

Cell[BoxData[
    \(527044673712659\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(chiffre2 = PowerMod[text2, a, n]\)], "Input"],

Cell[BoxData[
    \(403187965321648\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Entschl\[UDoubleDot]sselung - Dechiffrierung", "Subtitle"],

Cell[TextData[{
  "Zuerst brauchen wir den geheimen Schl\[UDoubleDot]ssel - passend zum \
\[ODoubleDot]ffentlichen Schl\[UDoubleDot]ssel a, n.\n\nWir \
w\[ADoubleDot]hlen den geheimen Schl\[UDoubleDot]ssel b so, dass das Produkt \
a . b kongruent 1 bez\[UDoubleDot]glich des Modulus m ist. Dies ist \
gleichbedeutend mit b = a^(-1) mod m. Daf\[UDoubleDot]r verwenden wir den \
Befehl \n",
  StyleBox["PowerMod[a, -1, m]",
    FontWeight->"Bold"]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(b = PowerMod[a, \(-1\), m]\)], "Input"],

Cell[BoxData[
    \(164067815519273\)], "Output"]
}, Open  ]],

Cell["\<\
Anschlie\[SZ]end kann die Entschl\[UDoubleDot]sselung \
durchgef\[UDoubleDot]hrt werden - analog zur Verschl\[UDoubleDot]sselung, \
aber mit Hilfe des geheimen Schl\[UDoubleDot]ssels!\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(rein1 = PowerMod[chiffre1, b, n]\)], "Input"],

Cell[BoxData[
    \(758289808479\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(rein2 = PowerMod[chiffre2, b, n]\)], "Input"],

Cell[BoxData[
    \(718265707369\)], "Output"]
}, Open  ]],

Cell["Vergleich mit dem urspr\[UDoubleDot]nglichen Text:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(text1 \[Equal] rein1\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(text2 \[Equal] rein2\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
WindowSize->{934, 753},
WindowMargins->{{Automatic, 27}, {Automatic, 0}},
Magnification->1.25,
StyleDefinitions -> "Default.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 30, 0, 117, "Title"],
Cell[1809, 55, 62, 0, 64, "Subtitle"],
Cell[1874, 57, 940, 31, 103, "Text"],

Cell[CellGroupData[{
Cell[2839, 92, 65, 1, 35, "Input"],
Cell[2907, 95, 42, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2986, 101, 42, 1, 35, "Input"],
Cell[3031, 104, 38, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3106, 110, 65, 1, 35, "Input"],
Cell[3174, 113, 42, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3253, 119, 42, 1, 35, "Input"],
Cell[3298, 122, 38, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3373, 128, 41, 1, 35, "Input"],
Cell[3417, 131, 50, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3504, 137, 60, 1, 35, "Input"],
Cell[3567, 140, 50, 1, 35, "Output"]
}, Open  ]],
Cell[3632, 144, 652, 16, 82, "Text"],

Cell[CellGroupData[{
Cell[4309, 164, 61, 1, 35, "Input"],
Cell[4373, 167, 38, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4448, 173, 42, 1, 35, "Input"],
Cell[4493, 176, 35, 1, 35, "Output"]
}, Open  ]],
Cell[4543, 180, 666, 16, 165, "Text"],
Cell[5212, 198, 933, 32, 95, "Input"],
Cell[6148, 232, 988, 38, 56, "Input"],

Cell[CellGroupData[{
Cell[7161, 274, 53, 1, 35, "Input"],
Cell[7217, 277, 46, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7300, 283, 53, 1, 35, "Input"],
Cell[7356, 286, 46, 1, 35, "Output"]
}, Open  ]],
Cell[7417, 290, 139, 3, 35, "Input"],

Cell[CellGroupData[{
Cell[7581, 297, 65, 1, 35, "Input"],
Cell[7649, 300, 49, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7735, 306, 65, 1, 35, "Input"],
Cell[7803, 309, 49, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7889, 315, 64, 0, 64, "Subtitle"],
Cell[7956, 317, 457, 9, 122, "Text"],

Cell[CellGroupData[{
Cell[8438, 330, 59, 1, 35, "Input"],
Cell[8500, 333, 49, 1, 35, "Output"]
}, Open  ]],
Cell[8564, 337, 207, 4, 38, "Text"],

Cell[CellGroupData[{
Cell[8796, 345, 65, 1, 35, "Input"],
Cell[8864, 348, 46, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8947, 354, 65, 1, 35, "Input"],
Cell[9015, 357, 46, 1, 35, "Output"]
}, Open  ]],
Cell[9076, 361, 66, 0, 38, "Text"],

Cell[CellGroupData[{
Cell[9167, 365, 53, 1, 35, "Input"],
Cell[9223, 368, 38, 1, 35, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9298, 374, 53, 1, 35, "Input"],
Cell[9354, 377, 38, 1, 35, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

